function genericOnClick(info, tab) {
  chrome.storage.local.get(function(data) {
    for (var key in data) {
      if (key == parseInt(key)) {
        if (data[key].name == info.menuItemId) {
          chrome.tabs.move(tab.id, {windowId: parseInt(key), index: -1});
          _gaq.push(['_trackEvent', 'context_menus', 'moved to open']);
          return;
        }
      }
    }

    for (var window_name in data['UltiTab-Window']) {
      if (info.menuItemId == window_name) {
        if (data['UltiTab-Window'][window_name].read_only) {
          return;
        }

        data['UltiTab-Window'][window_name].tabs.push(tab);

        chrome.storage.local.set({'UltiTab-Window': data['UltiTab-Window']}, function() {
          chrome.storage.local.get("UltiTab-Window", function(current_data) {
            var current_data_tags = current_data['UltiTab-Window'][info.menuItemId].tabs;

            if (current_data_tags[current_data_tags.length - 1].url == tab.url) {
              chrome.tabs.remove(tab.id);
              _gaq.push(['_trackEvent', 'context_menus', 'moved to saved']);
            }

          });
        });

        break;
      }
    }
  });
}

function buildContextMenu() {
  chrome.contextMenus.removeAll(function() {
    chrome.storage.local.get('UltiTab-Window', function(data) {
      var page_parent = chrome.contextMenus.create({
          "id": 'page_parent',
          "title": "Send tab to saved window:",
          "contexts": ['page']
        }
      );

      for (var tab_name in data['UltiTab-Window']) {
        var title = tab_name;

        if (data['UltiTab-Window'][tab_name].read_only) {
          title = title + ' (Autosave Paused)';
        }

        chrome.contextMenus.create({"id": tab_name, "title": title, "parentId": page_parent});
      }
    });
  });
}

chrome.contextMenus.onClicked.addListener(genericOnClick);