function pageInit() {
	var landing_page_container = document.getElementById("landing_page_container"),
		query_string = {},
		lookup = undefined;

	window.location.search.substring(1).split("&").map(function(pairings) {
		var query_elms = pairings.split("=");

		if (query_elms.length == 1) {
			return;
		}

		query_string[decodeURI(query_elms[0])] = decodeURI(query_elms[1]);
	});

	chrome.storage.local.get("UltiTab-Window", function(data) {
		if (query_string.name !== undefined &&
			data['UltiTab-Window'][query_string.name]) {
				data['UltiTab-Window'][query_string.name].name = query_string.name;
				landing_page_container.appendChild(windowDisplayBuilder(data['UltiTab-Window'][query_string.name]));
		} else {
			for (let i in data['UltiTab-Window']) {
				data['UltiTab-Window'][i].name = i;
				landing_page_container.appendChild(windowDisplayBuilder(data['UltiTab-Window'][i]));
			}
		}
	});
}

function windowDisplayBuilder(window) {
	var whole_container = document.createElement("div"),
		header = document.createElement("div"),
		body = document.createElement("div");

	whole_container.style.display = "block";

	header.innerHTML = "<h3>" + window.name + "</h3>Number of tabs: (" + window.tabs.length + ")";

	for (let i = 0; i < window.tabs.length; i++) {
		let tab_info_container = document.createElement("div"),
			title = document.createElement("span"),
			url = document.createElement("span"),
			separator = document.createElement("span");

		separator.style.display = "inline-block";
		separator.innerHTML = "&nbsp;|&nbsp;";

		title.style.display = "inline-block";
		url.style.display = "inline-block";

		title.innerText = window.tabs[i].title;
		url.innerText = (window.tabs[i].url.length > 190 ? window.tabs[i].url.substring(0, 190) + "..." : window.tabs[i].url);

		tab_info_container.style.display = "block";

		tab_info_container.appendChild(title);

		tab_info_container.appendChild(separator);
		tab_info_container.appendChild(url);

		body.appendChild(tab_info_container);
	}

	whole_container.appendChild(header);
	whole_container.appendChild(body);

	return whole_container;
}

pageInit();