Raven.context(function() {
	var old_pin = document.createElement("input"),
		new_pin = document.createElement("input"),
		confirm = document.createElement("input"),
		set_button = document.createElement("button"),
		dark_theme = document.getElementById("dark_theme"),
		windows_with_keys = [],
		response_timeout = null,
		response_timeout_cleaner = null,
		lock = {};

	set_button.className = 'submit-button btn';

	old_pin.setAttribute("type", "password");
	old_pin.setAttribute("maxlength", "4");
	old_pin.setAttribute("placeholder", "Old pin");
	old_pin.style.display = 'none';

	new_pin.setAttribute("type", "password");
	new_pin.setAttribute("maxlength", "4");
	new_pin.setAttribute("placeholder", "New pin");

	confirm.setAttribute("type", "password");
	confirm.setAttribute("maxlength", "4");
	confirm.setAttribute("placeholder", "Confirm new pin");

	set_button.innerText = 'Confirm';

	set_button.addEventListener("click", function() {
		var last_message = document.getElementById("last_message");

		last_message.style.fontWeight = 'bold';
		last_message.style.color = 'red';

		if (new_pin.value != parseInt(new_pin.value)) {
			last_message.innerText = 'Enter a number without .,- between 0-9999';
			set_button.removeAttribute('disabled');
			return;
		}

		set_button.setAttribute('disabled', true);

		setTimeout(function() {
			set_button.removeAttribute('disabled');
		}, 3000);

		last_message.innerText = '';

		if (typeof lock_code.lock_code != 'undefined' &&
			lock_code.lock_code != md5(old_pin.value.trim())
		) {
			last_message.innerText = 'Old pin does not match.';
			set_button.removeAttribute('disabled');
			return;
		} else if (new_pin.value.trim() != '' && (new_pin.value < 0 || new_pin.value > 9999)) {
			last_message.innerText = 'New pin must be greater than 0 and less than 9999';
			set_button.removeAttribute('disabled');
			return;
		} else if (new_pin.value != confirm.value) {
			last_message.innerText = 'Confirmation pin does not match new pin.';
			set_button.removeAttribute('disabled');
			return;
		}

		lock_code.lock_code = md5(new_pin.value);

		chrome.storage.local.set({"lock_code": lock_code.lock_code}, function() {
			last_message.style.color = 'green';
			last_message.innerText = 'Pin updated.';
			old_pin.value = '';
			new_pin.value = '';
			confirm.value = '';
		});
	});

	chrome.storage.local.get("customize", function(custom_data) {
		if (typeof custom_data.customize === 'undefined' || custom_data.customize.browser_action_icon === 0) {
		} else {
			dark_theme.querySelector("input").checked = true;
		}
	});

	dark_theme.addEventListener("click", function() {
		if (dark_theme.querySelector("input").checked === true) {
			chrome.storage.local.set({customize:{browser_action_icon: 1}}, function() {
				chrome.runtime.sendMessage({
					type: "change_browser_icon",
					content: {
						browser_action_icon: 1
					}
				});
			});
		} else {
			chrome.storage.local.set({customize:{browser_action_icon: 0}}, function() {
				chrome.runtime.sendMessage({
					type: "change_browser_icon",
					content: {
						browser_action_icon: 0
					}
				});
			});
		}
	});

	chrome.storage.local.get("lock_code", function(lock_set) {
		lock_code = lock_set;

		if (typeof lock_code.lock_code != 'undefined') {
			old_pin.style.display = 'inline-block';
		}
	});

	var pin_section = document.getElementById("pin_section");
	var button_section = document.getElementById("button_section");

	pin_section.appendChild(old_pin);
	pin_section.appendChild(document.createElement('br'));
	pin_section.appendChild(new_pin);
	pin_section.appendChild(document.createElement('br'));
	pin_section.appendChild(confirm);
	pin_section.appendChild(document.createElement('br'));

	button_section.appendChild(set_button);

	chrome.storage.local.get(['UltiTab-Window', 'instance_id'], function(saved_windows) {

		var export_section = document.getElementById("export"),
			export_selection_container = document.createElement("p"),
			export_title = document.createElement("span"),
			option_set = document.createElement("select"),
			share_button = document.createElement("button"),
			remove_windows_container = document.createElement("div"),
			remove_title = document.createElement("h5"),
			copy_action = document.createElement("div"),
			import_section = document.getElementById("import"),
			import_container = document.createElement("p"),
			import_header = document.createElement("h5"),
			import_text = document.createElement("input"),
			import_button = document.createElement("button"),
			share_button_container = document.createElement("div"),
			share_button_text = document.createElement("span"),
			import_button_container = document.createElement("div"),
			import_button_text = document.createElement("span");

		copy_action.id = "response_text";

		copy_action.innerHTML = "&nbsp;";

		share_button_text.className = 'response-text';
		import_button_text.className = 'response-text';

		option_set.id = 'export_selection';
		remove_windows_container.innerText = '';
		export_section.innerText = '';

		export_title.innerText = "Pick a window to Share. Vaux will generate a url you can give to other Vaux users.";

		export_section.appendChild(export_title);

		var option_built = optionBuilder(export_section, export_selection_container, remove_windows_container, option_set, saved_windows, windows_with_keys);

		export_selection_container = option_built[0];
		remove_windows_container = option_built[1];

		export_section.appendChild(export_selection_container);

		share_button.className = 'submit-button btn';
		share_button.innerText = 'Share';

		share_button_container.appendChild(share_button);
		share_button_container.appendChild(share_button_text);

		export_section.appendChild(share_button_container);

		share_button.addEventListener("click", function() {
			var selections = document.querySelectorAll("option:checked"),
				exported_window = {};

			share_button.setAttribute("disabled", true);

			share_button.style.border = 'thin solid blue';

			for (var i = 0; i < selections.length; i++) {
				exported_window = {
					name: selections[i].value,
					tabs: saved_windows['UltiTab-Window'][selections[i].value].tabs.map(function(tab) {
						return {url: tab.url};
					})
				};
			}

			share_button_text.innerText = '';

			if (Object.keys(exported_window).length > 0) {
				var http_request = new XMLHttpRequest(),
					update = (typeof saved_windows['UltiTab-Window'][exported_window.name].saved_window_url != 'undefined' ? true : false),
					http_method = (update == true ? 'PUT' : 'POST'),
					endpoint = (update == true ? saved_windows['UltiTab-Window'][exported_window.name].saved_window_url : getEndpoint() + saved_windows['instance_id']);

				http_request.open(http_method, endpoint, true);
				http_request.setRequestHeader("Content-Type", "application/json");

				http_request.onreadystatechange = function() {
					if (http_request.readyState === XMLHttpRequest.DONE) {
						share_button.removeAttribute("disabled");

						if (http_request.status == 200) {
							if (update === false) {
								var payload = JSON.parse(http_request.responseText);

								saved_windows['UltiTab-Window'][exported_window.name].saved_window_url = payload.url;
								chrome.storage.local.set({'UltiTab-Window': saved_windows['UltiTab-Window']});

								if (windows_with_keys.length == 0) {
									remove_windows_container.innerText = '';
								}

								windows_with_keys.push({name: exported_window.name, url: payload.url});
								removeBuilder(windows_with_keys[(windows_with_keys.length - 1)], windows_with_keys, remove_windows_container, saved_windows);

								_gaq.push(['_trackEvent', 'export_window', 'created']);
							} else {
								_gaq.push(['_trackEvent', 'export_window', 'updated']);
							}
						} else if (http_request.status != 200) {
							share_button.style.border = 'thin solid red';
							share_button_text.innerText = 'Error sharing window.';
							Raven.captureMessage('Error occured with window export.');
						}
					}
				}

				http_request.send(JSON.stringify(exported_window));
			} else {
				share_button_text.innerText = 'No window selected.';
			}
		});

		remove_title.innerHTML = 'Shared windows:<br /><small>(Click to show the link.)</small>';

		export_section.appendChild(remove_title);

		export_section.appendChild(copy_action);

		export_section.appendChild(remove_windows_container);

		import_header.innerText = "Import window:";
		import_text.setAttribute("type", "text");
		import_text.setAttribute("placeholder", "Import Vaux Url");
		import_button.className = "submit-button btn";
		import_button.innerText = "Import";

		import_button.addEventListener("click", function() {
			import_button.setAttribute("disabled", true);

			if (import_text.value.trim() == "") {
				import_button.removeAttribute("disabled");
				return;
			}

			import_button.style.border = 'thin solid blue';

			if (!import_text.value.match(getEndpointRegex())) {
				import_button.removeAttribute("disabled");
				return;
			}

			import_button_text.innerText = '';

			var http_request = new XMLHttpRequest();
			var error_callback = function() {
				import_button.style.border = 'thin solid red';
				import_button_text.innerText = 'Error importing window.';
				Raven.captureMessage('Error occured with window import.');
			};

			http_request.open('GET', import_text.value, true);
			http_request.setRequestHeader("Content-Type", "application/json");

			http_request.onreadystatechange = function() {
				if (http_request.readyState === XMLHttpRequest.DONE) {

					import_button.removeAttribute("disabled");

					if (http_request.status == 200) {
						var payload = JSON.parse(http_request.responseText);

						if (typeof payload.name === "undefinded") {
							error_callback();
							return;
						}

						import_text.value = '';

						payload.name = payload.name + ' [Imported]';

						payload.incognito = false;
						payload.read_only = false;
						payload.lock = false;

						if (typeof saved_windows['UltiTab-Window'][payload.name] === 'undefined') {
							saved_windows['UltiTab-Window'][payload.name] = {};
						}

						saved_windows['UltiTab-Window'][payload.name] = payload;

						chrome.storage.local.set({'UltiTab-Window': saved_windows['UltiTab-Window']}, function() {
							_gaq.push(['_trackEvent', 'import_window', 'imported']);
							buildContextMenu();
							optionBuilder(export_section, export_selection_container, remove_windows_container, option_set, saved_windows, windows_with_keys);
						});
					} else if (http_request.status != 200) {
						error_callback();
					}
				}
			}

			http_request.send(null);
		});

		import_container.appendChild(import_header);
		import_container.appendChild(import_text);
		import_section.appendChild(import_container);
		import_button_container.appendChild(import_button);
		import_button_container.appendChild(import_button_text);
		import_section.appendChild(import_button_container);
	});

	function optionBuilder(export_section, export_selection_container, remove_windows_container, option_set, saved_windows, windows_with_keys) {
		var options = document.querySelectorAll("option");

		for (var i = 0; i < options.length; i++) {
			option_set.removeChild(options[i]);
		}

		export_selection_container.innerText = '';
		remove_windows_container.innerText = '';

		if (typeof saved_windows['UltiTab-Window'] != 'undefined' && Object.keys(saved_windows['UltiTab-Window']) == 0) {
			var option_group = document.createElement("optgroup");
			option_group.innerText = 'No saved windows found';
			export_selection_container.appendChild(option_group);
		} else {
			windows_with_keys.splice(0, windows_with_keys.length);

			for (var key in saved_windows['UltiTab-Window']) {
				var option = document.createElement("option");
				option.value = key;
				option.innerText = key;
				option_set.appendChild(option);

				if (typeof saved_windows['UltiTab-Window'][key].saved_window_url != 'undefined') {
					windows_with_keys.push({name: key, url: saved_windows['UltiTab-Window'][key].saved_window_url});
				}
			}
		}

		export_selection_container.appendChild(option_set);

		if (windows_with_keys.length > 0) {
			for (var url_idx = 0; url_idx < windows_with_keys.length; url_idx++) {
				removeBuilder(windows_with_keys[url_idx], windows_with_keys, remove_windows_container, saved_windows);
			}
		} else {
			var no_shares = document.createElement("p");
			no_shares.innerText = 'No shared windows.';
			remove_windows_container.appendChild(no_shares);
		}

		return [export_selection_container, remove_windows_container];
	}

	function removeBuilder(removed_window_info, windows_with_keys, parent, saved_windows) {
		var remove_container = document.createElement("div"),
			window_title = document.createElement("span"),
			remove_button = document.createElement("span"),
			window_url = document.createElement("span"),
			copy_button = document.createElement("span"),
			window_show_toggle = false;

		remove_button.setAttribute("title", "Delete link");

		remove_container.className = 'removed-window-container';

		window_title.innerText = removed_window_info.name;
		window_title.className = 'remove-window-element edit-icon';

		window_title.setAttribute("title", "Click for url");

		window_url.className = "window-url";

		window_url.innerText = removed_window_info.url;

		remove_button.className = 'glyphicon glyphicon-trash edit-icon saved-window-toggle removed-item';

		copy_button.className = "glyphicon glyphicon-copy edit-icon saved-window-toggle removed-item";

		copy_button.setAttribute("title", "Add to clipboard");

		remove_button.addEventListener("mouseover", function() {
			remove_button.style.color = "red";
		});

		remove_button.addEventListener("mouseout", function() {
			remove_button.style.color = "#333";
		});

		remove_button.addEventListener("click", function() {
			var http_request = new XMLHttpRequest();

			http_request.open("DELETE", removed_window_info.url, true);
			http_request.setRequestHeader("Content-Type", "application/json");

			http_request.onreadystatechange = function() {
				if (http_request.readyState === XMLHttpRequest.DONE && http_request.status == 200) {
					delete saved_windows['UltiTab-Window'][removed_window_info.name].saved_window_url;
					chrome.storage.local.set({'UltiTab-Window': saved_windows['UltiTab-Window']});

					for (var i = 0; i < windows_with_keys.length; i++) {
						if (windows_with_keys[i].name == removed_window_info.name) {
							windows_with_keys.slice(i, 1);
						}
					}

					window_title.style.display = 'none';
					remove_button.style.display = 'none';
					window_url.style.display = 'none';
					copy_button.style.display = 'none';

				} else if (http_request.status != 200) {
					Raven.captureMessage('Error occured with window export.');
				}
			}

			http_request.send(null);
		});

		window_title.addEventListener("click", function() {
			window_show_toggle = !window_show_toggle;

			if (window_show_toggle) {
				window_url.style.display = "block";
				window_url.style.visibility = "visible";
			} else {
				window_url.style.display = "none";
				window_url.style.visibility = "hidden";
			}
		});

		copy_button.addEventListener("click", function() {
			window_show_toggle = false;
			window_title.click();
			var range = document.createRange();
			range.selectNodeContents(window_url);
			window.getSelection().removeAllRanges();
			window.getSelection().addRange(range);
			document.execCommand("Copy");
			writeBottomText(null, "Copied", false, response_timeout, response_timeout_cleaner);
		});

		remove_container.appendChild(remove_button);
		remove_container.appendChild(window_title);
		remove_container.appendChild(copy_button);
		remove_container.appendChild(window_url);
		parent.appendChild(remove_container);
	}

	function getEndpoint() {
		return "https://vauxapp.com/api/";
	}

	function getEndpointRegex() {
		return new RegExp("http[s]?://(www.)?vaux(app.com|.in)+/api");
	}
});