function syncTabs(windowId) {
  chrome.storage.local.get(windowId.toString(), function(data) {
    if (typeof data[windowId.toString()] != 'undefined' &&
        typeof data[windowId.toString()].name != 'undefined'
    ) {
      try {
        chrome.windows.get(windowId, {populate: true}, function(windowInfo) {
          if (chrome.runtime.lastError) {
            return;
          }

          chrome.storage.local.get('UltiTab-Window', function(windows) {
            if (windows['UltiTab-Window'][data[windowId.toString()].name] &&
                windowInfo
            ) {
              if (windows['UltiTab-Window'][data[windowId.toString()].name].read_only) {
                return true;
              }

              windows['UltiTab-Window'][data[windowId.toString()].name].tabs = windowInfo.tabs;
              windows['UltiTab-Window'][data[windowId.toString()].name].incognito = windowInfo.incognito;
              windows['UltiTab-Window'][data[windowId.toString()].name].read_only = false;
              windows['UltiTab-Window'][data[windowId.toString()].name].position = {
                top: windowInfo.top,
                left: windowInfo.left,
                width: windowInfo.width,
                height: windowInfo.height,
                state: windowInfo.state
              };

              chrome.storage.local.set({
                  "UltiTab-Window": windows['UltiTab-Window']
                },
                function() {}
              );
            }
          });
        });
      } catch (e) {}
    }
  });
}

function removeTabs(windowId) {
  chrome.windows.get(windowId, function(windowInfo) {
    if (chrome.runtime.lastError) {
      return;
    }

    syncTabs(windowId);
  });
}
